<template>
  <div class="card h-100">
    <div class="card-header pr-0">
      <slot name="header"></slot>
    </div>
    <div
      class="card-body d-flex flex-column px-4 py-3 text-center justify-content-between"
    >
      <slot name="pretitle"></slot>
      <ContentLoader v-if="skeleton" width="300" height="20">
        <rect x="0" y="0" rx="10" ry="10" width="300" height="20" />
      </ContentLoader>
      <h3
        v-else
        v-b-tooltip.hover.top="{ variant: 'dark' }"
        :title="title.length >= 35 ? title : ''"
        class="card-title card-long-title mb-0 text font-weight-bold"
      >
        <NuxtLink v-if="internalLink" :to="internalLink">{{ title }}</NuxtLink>
        <a
          v-if="externalLink"
          :href="externalLink"
          target="_blank"
          class="cursor-pointer text-decoration-none"
          >{{ title }}</a
        >
        <span v-if="!internalLink && !externalLink">{{ title }}</span>
      </h3>
      <slot name="subtitle"></slot>
      <slot name="userdate">
        <div class="mt-3 mb-3">
          <b-row align-h="center" class="g-0">
            <b-col sm="auto">
              <span
                v-b-tooltip.hover.right="{ variant: 'dark' }"
                :title="firstName"
              >
                {{ firstName }}
              </span>
            </b-col>
            <b-col v-if="firstName" sm="auto" class="d-none d-sm-block"
              >,</b-col
            >
            <b-col sm="auto" class="ml-1">
              <span
                v-b-tooltip.hover.bottom="{ variant: 'dark' }"
                :title="date | timeago"
              >
                {{ date | formatDate('PP') | stripComma }}
              </span>
            </b-col>
          </b-row>
        </div>
      </slot>
      <slot name="body-top"></slot>
      <slot name="body-bottom"></slot>
      <slot name="description"></slot>
      <div class="d-flex justify-content-center align-items-center">
        <slot name="badges"></slot>
      </div>
    </div>
    <slot name="progress"></slot>
  </div>
</template>

<script>
import introJs from 'intro.js';
export default {
  props: {
    title: {
      type: String,
      default: '',
    },
    mainUser: {
      type: Object,
      default() {
        return {
          fullName: '',
          firstName: '',
        };
      },
    },
    date: {
      type: String,
      default: '',
    },
    internalLink: {
      type: String,
      default: '',
    },
    externalLink: {
      type: String,
      default: '',
    },
    skeleton: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    firstName() {
      return (
        this.mainUser.firstName ||
        this.mainUser.first_name ||
        this.mainUser.username
      );
    },
  },
  beforeDestroy() {
    introJs().removeHints();
  },
};
</script>
